/**
  ******************************************************************************
  * @file    main.c
  * @author  MCU Application Team
  * @brief   Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2023 Puya Semiconductor Co.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by Puya under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2016 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "iap.h"
#include "flash.h"

/* Private variables ---------------------------------------------------------*/
/* Private user code ---------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/

/**
 * @brief  Configure system clock.
 */
static void ConfigureClock(void)
{
  /* Set the HSI clock to 8MHz by default */
  /* Read HSI(8M) clock calibration value */
  RCC->ICSCR = (RCC->ICSCR & 0xFFF80000) | \
               ((*(uint32_t *)(0x1FFF1100)) & 0x0007FFFF);

  /* Waiting for the HSI clock to stabilize */
  while (RCC_CR_HSIRDY != READ_BIT(RCC->CR, RCC_CR_HSIRDY));

  /* Select HSI as the PLL input source */
  CLEAR_BIT(RCC->PLLCFGR, RCC_PLLCFGR_PLLSRC);

  /* HSI 6x frequency to PLL: 48M */
  MODIFY_REG(RCC->PLLCFGR, RCC_PLLCFGR_PLLMUL, RCC_PLLCFGR_PLLMUL_2);

  /* Enable PLL */
  SET_BIT(RCC->CR, RCC_CR_PLLON);

  /* Waiting for the PLL clock to stabilize */
  while (RCC_CR_PLLRDY != READ_BIT(RCC->CR, RCC_CR_PLLRDY));

  #define ACR_LATENCY      (0x3UL << 0U)      
  #define LATENCY_1        (0x1UL << 0)   

  /* Program the new number of wait states to the LATENCY bits in the FLASH_ACR register */
  MODIFY_REG(FLASH->ACR, ACR_LATENCY, LATENCY_1);
  while ((FLASH->ACR & ACR_LATENCY) != LATENCY_1);

  /* Choose (PLL / 2) as the system clock */
  MODIFY_REG(RCC->CFGR, RCC_CFGR_SW, RCC_CFGR_SW_1);
  while (RCC_CFGR_SWS_1 != READ_BIT(RCC->CFGR, RCC_CFGR_SWS));
}

/**
 * @brief  Application entry point.
 */
int main(void)
{
  /* Configure user button */
  BSP_PB_Init(BUTTON_USER, BUTTON_MODE_GPIO);

  /* Check if the user button is pressed */
  if (BSP_PB_GetState(BUTTON_USER) == 0x01)
  {
    /* Reset of all peripherals, Initializes the Systick */
    ConfigureClock();

    /* Initialize IAP-related parameters */
    IAPInit();

    while (1)
    {
      /* IAP Execution */
      IAPProcess();
    }
  }
  
  /* Jump to the app */
  JumpToAddress(APP_ADDR);
  
  while (1)
  {

  }
}


/**
  * @brief  Error executing function.
  * @param  None
  * @retval None
  */
void APP_ErrorHandler(void)
{
  while (1)
  {
  }
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* Users can add their own printing information as needed,
     for example: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* Infinite loop */
  while (1)
  {
  }
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT Puya *****END OF FILE******************/
